#include "Case.hpp"

Case::Case(void){ //constructeur
  etat=0; //pour commencer la case est vide
  valeur=0; /*au dbut du jeu la case ne vaut pas forcement 0
	      (dpend de la valeur attribuee a un quintuplet
	      vide) mais elle sera mise a jour plus tard */
  quintuplets = new Liste_quintuplets(); /*Pour pouvoir fabriquer un quintuplet, il faut
					   que toutes les cases soient construites. On ne 
					   peux dc pas remplir ds maintenant la liste
					   des quintuplets passant par cette case mais il
					   faut deja l'initialiser */
  cases_voisines = new Liste_cases(); /*mm remarque */
};

void Case::ajoute_quintuplet(Quintuplet* quint){ //ajoute un quint a la liste 'quintuplets'
  quintuplets->ajouter(quint);
}

void Case::ajoute_case_voisine(Case* Xcase){ //ajoute une case a la liste 'cases_voisines'
  cases_voisines->ajouter(Xcase);
}

int Case::calcule_valeur(void){ //calcule et retourne la valeur de la case
  valeur = quintuplets->retourne_valeur_liste();
  return valeur;
}

int Case::retourne_valeur(void){ //retourne simplement la valeur
  return valeur;
}

int Case::retourne_etat(void){ //retourne l'etat
  return etat;
}

int Case::mise_a_jour(int val_etat){ /*Met un 'pion' sur cette case (change le champ 'etat') en
				       verifiant si c'est permis  puis met a jour la valeur
				       des quint de la liste 'quintuplets', de la case 
				       courante et des cases voisines. Retourne:
				       -2 si la case n'tait pas vide (on ne peut pas jouer ici)
				       -1 pour tout autre erreur
				       0 si tout se passe normalement
				       1 si 5 croix allignees
				       2 si 5 ronds allignes  */
  if ((etat != VIDE)&&(val_etat != VIDE)) return -2; //on ne peut pas jouer sur cette case
  else{
    etat = val_etat;
    switch (quintuplets->mise_a_jour()){ //calcule la valeur des quint de la liste 'quintuplets'
    case 0: //tout s'est passe normalement
      break;
    case 1: //au moins une fois 5 croix allignees
      return 1;
      break;
    case 2: //au moins une fois 5 ronds allignes
      return 2;
      break;
    default:
      return -1;
    }
    calcule_valeur(); //calcule la valeur de la case courante
    cases_voisines->calcule_valeur(); //calcule la valeur des cases voisines
    return 0;
  }
}

void Case::reset(void){
  etat = VIDE;
}
void Case::reinitialise(void){
  quintuplets->mise_a_jour();
  calcule_valeur();
}

// Pour le debuggage:
void Case::affiche(void){ //affiche la valeur d'une case sur la ligne de commande
  cout.width(7);
  cout << valeur << " |";
}








