#ifndef CONST_H
#define CONST_H

const int N=20; //taille du tableau
const int NB_QUINT=(4*(N-4)*(N-2)); //nb de quintuplets

//Constantes definissant les boites de dialogue appellees
const int JOUEUR_GAGNE=0;
const int JOUEUR_PERD=1;
const int RECOMMENCE_PARTIE=2;
const int QUITTER=3;
const int CHANGE_QUI_COMMENCE=4;

//Constantes definissant les boites d'info appellees
const int SAVE_OK=0;
const int CHARGE_OK=1;
const int CHARGE_NOT_OK=2;

//Valeurs pour le champ 'qui_commence' du plateau 
const int JOUEUR_COMMENCE=0;
const int ORDI_COMMENCE=1;

//Valeurs pour le champ 'etat' des cases
const int VIDE=0;
const int CROIX=1; //joueur
const int ROND=2; //ordi
const int NONE=9; //personne (coup annule)

/*
  nb de points attribues aux quintuplets
  determinant la strategie de l'ordinateur
*/
// commun aux 2 joueurs
const int Vide_score=7;
const int OX_score=0;
// spcifique au joueur 1
const int X_score=15;
const int XX_score=400;
const int XXX_score=1800;
const int XXXX_score=100000;
// spcifique au joueur 2
const int O_score=35;
const int OO_score=800;
const int OOO_score=15000;
const int OOOO_score=800000;

#endif
