#include <iostream.h>
#include <stdio.h>
#include <string.h>
//#include <stdbool.h>
#include <gtk/gtk.h>
#include "Plateau.hpp"

/*********************************
  Gestion de la fenetre principale
**********************************/

void changer_bouton(GtkObject* Case_graphique, int tab_coups[N][N]); //remet a jour une case
void sauver(GtkObject* Fenetre); //sauvegarde la partie ds 'fichier_courant'
void quitter(GtkWidget* Table); //quitte le pgm (boite de dialogue)
void recommencer(GtkWidget* Table); //recommence une nouvelle partie (boite de dialogue)
void annuler_un_coup(GtkWidget* Table); //le joueur demande d'annuler son dernier coup
void jouer_manu(GtkObject* Case_graphique, GtkWidget* Table); //le joueur joue ds une case
void jouer_auto(GtkWidget* Table); //l'ordi joue ds une case
void changer_qui_commence(GtkWidget *Table); //change celui qui doit commencer la partie
void fenetre_principale(Plateau* plateau); //mise en place et affichage de la fenetre principale

/*******************************
  Gestion des boites de dialogue
********************************/

void rien(void); //pour empecher de fermer la boite de dialogue avec 'close'
void reset_bouton(GtkObject* Case_graphique); //RAZ d'une seule case
void reset_plateau(GtkObject* Table); //RAZ du plateau entier
void boite_dialogue(GtkWidget* Table,int type); //mise en place et affichage de la boite de dialogue

/***************************
  Gestion des boites d'info
****************************/

void boite_info(GtkWidget* Fenetre, int type, char* fichier); //mise en place et affichage de la boite d'info

/*********************************************
  Gestion des boites de selection de fichiers
**********************************************/

void sauver_sous(GtkFileSelection *SelFichier, GtkObject* Bouton); /* sauvegarde la partie ds le fichier 
								      selectionne ds 'boite_sauvegarder' */
void boite_sauvegarder(GtkWidget *Fenetre); //Boite pour selectionner un fichier a sauvegarder
void charger(GtkFileSelection *SelFichier, GtkObject* Bouton); /* charge une partie selectionne
								  a partir de 'boite_charger' */
void boite_charger(GtkWidget *Table); //Boite pour selectionner un fichier a charger


